//+------------------------------------------------------------------+
//|                                                    ATR ratio.mq4 |
//|                         Copyright  2005, Luis Guilherme Damiani |
//|                                      http://www.damianifx.com.br |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Luis Guilherme Damiani"
#property link      "http://www.damianifx.com.br"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_color2 Violet
#property indicator_color3 Gold
//---- input parameters
extern int       short_atr=7;
extern int       long_atr=49;
extern double    triglevel=1.00;
extern int       SlopeLookback = 1;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   
   if( SlopeLookback < 1 )
   {
      Alert("SlopeLookback must be > 1.");
      Alert("You set SlopeLookback = " + IntegerToString(SlopeLookback));
      return(INIT_FAILED);
   }

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   //Comment("ATR ratio= "+short_atr+" / "+long_atr);
   for(int i=Bars-counted_bars-1;i>=0;i--)
   {
      ExtMapBuffer1[i]=triglevel;
      double sa=iATR(NULL,0,short_atr,i);
      
      double denominator = iATR(NULL,0,long_atr,i);   
      
      ExtMapBuffer2[i]= sa;
      
      if( denominator != 0 )
         ExtMapBuffer2[i]= sa / denominator;
      
      if( i >= Bars-counted_bars-SlopeLookback && ExtMapBuffer3[i] == NULL  )
         ExtMapBuffer3[i] = ExtMapBuffer2[i];
      else
      {
         double slope = ExtMapBuffer2[i]-ExtMapBuffer2[i+SlopeLookback];
         
         if( slope > 0 )
            ExtMapBuffer3[i] = 1;
         else if( slope < 0   )
            ExtMapBuffer3[i] = -1;
            else
               ExtMapBuffer3[i] = 0;
      }
   }
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+